package parejas;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

/**
 * Created by TheL0w3R on 30/10/2018.
 * All Rights Reserved.
 */
public class MainForm extends JFrame {

    private GameManager gameManager;

    private JPanel mainPanel;
    private JToggleButton card1;
    private JToggleButton card2;
    private JToggleButton card3;
    private JToggleButton card4;
    private JToggleButton card5;
    private JToggleButton card6;
    private JToggleButton card7;
    private JToggleButton card8;
    private JLabel triesLabel;

    public MainForm() {
        super("Juego de parejas");

        gameManager = GameManager.getInstance();
        gameManager.setTriesLabel(triesLabel);

        this.setContentPane(mainPanel);
        this.pack();
        this.setResizable(false);
        this.setLocationRelativeTo(null);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        bindActions();

        this.setVisible(true);
    }

    private void bindActions() {
        card1.addItemListener(new CardAction(gameManager.consumeCard(), card1));
        card2.addItemListener(new CardAction(gameManager.consumeCard(), card2));
        card3.addItemListener(new CardAction(gameManager.consumeCard(), card3));
        card4.addItemListener(new CardAction(gameManager.consumeCard(), card4));
        card5.addItemListener(new CardAction(gameManager.consumeCard(), card5));
        card6.addItemListener(new CardAction(gameManager.consumeCard(), card6));
        card7.addItemListener(new CardAction(gameManager.consumeCard(), card7));
        card8.addItemListener(new CardAction(gameManager.consumeCard(), card8));
    }

    {
// GUI initializer generated by IntelliJ IDEA GUI Designer
// >>> IMPORTANT!! <<<
// DO NOT EDIT OR ADD ANY CODE HERE!
        $$$setupUI$$$();
    }

    /**
     * Method generated by IntelliJ IDEA GUI Designer
     * >>> IMPORTANT!! <<<
     * DO NOT edit this method OR call it in your code!
     *
     * @noinspection ALL
     */
    private void $$$setupUI$$$() {
        mainPanel = new JPanel();
        mainPanel.setLayout(new GridBagLayout());
        card1 = new JToggleButton();
        card1.setAlignmentY(0.5f);
        card1.setBackground(new Color(-855310));
        card1.setBorderPainted(false);
        card1.setContentAreaFilled(false);
        card1.setEnabled(true);
        card1.setFocusPainted(false);
        card1.setIcon(new ImageIcon(getClass().getResource("/res/back.png")));
        card1.setIconTextGap(0);
        card1.setMaximumSize(new Dimension(208, 319));
        card1.setMinimumSize(new Dimension(208, 319));
        card1.setOpaque(false);
        card1.setPreferredSize(new Dimension(208, 319));
        card1.setRequestFocusEnabled(true);
        card1.setRolloverEnabled(true);
        card1.setSelected(false);
        card1.setText("");
        card1.setVerifyInputWhenFocusTarget(true);
        card1.setVisible(true);
        GridBagConstraints gbc;
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.insets = new Insets(20, 20, 10, 10);
        mainPanel.add(card1, gbc);
        card2 = new JToggleButton();
        card2.setAlignmentY(0.5f);
        card2.setBackground(new Color(-855310));
        card2.setBorderPainted(false);
        card2.setContentAreaFilled(false);
        card2.setFocusPainted(false);
        card2.setIcon(new ImageIcon(getClass().getResource("/res/back.png")));
        card2.setIconTextGap(0);
        card2.setMaximumSize(new Dimension(208, 319));
        card2.setMinimumSize(new Dimension(208, 319));
        card2.setOpaque(false);
        card2.setPreferredSize(new Dimension(208, 319));
        card2.setSelected(false);
        card2.setText("");
        gbc = new GridBagConstraints();
        gbc.gridx = 1;
        gbc.gridy = 0;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.insets = new Insets(20, 10, 10, 10);
        mainPanel.add(card2, gbc);
        card3 = new JToggleButton();
        card3.setAlignmentY(0.5f);
        card3.setBackground(new Color(-855310));
        card3.setBorderPainted(false);
        card3.setContentAreaFilled(false);
        card3.setFocusPainted(false);
        card3.setIcon(new ImageIcon(getClass().getResource("/res/back.png")));
        card3.setIconTextGap(0);
        card3.setMaximumSize(new Dimension(208, 319));
        card3.setMinimumSize(new Dimension(208, 319));
        card3.setOpaque(false);
        card3.setPreferredSize(new Dimension(208, 319));
        card3.setSelected(false);
        card3.setText("");
        gbc = new GridBagConstraints();
        gbc.gridx = 2;
        gbc.gridy = 0;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.insets = new Insets(20, 10, 10, 10);
        mainPanel.add(card3, gbc);
        card4 = new JToggleButton();
        card4.setAlignmentY(0.5f);
        card4.setBackground(new Color(-855310));
        card4.setBorderPainted(false);
        card4.setContentAreaFilled(false);
        card4.setFocusPainted(false);
        card4.setIcon(new ImageIcon(getClass().getResource("/res/back.png")));
        card4.setIconTextGap(0);
        card4.setMaximumSize(new Dimension(208, 319));
        card4.setMinimumSize(new Dimension(208, 319));
        card4.setOpaque(false);
        card4.setPreferredSize(new Dimension(208, 319));
        card4.setSelected(false);
        card4.setText("");
        gbc = new GridBagConstraints();
        gbc.gridx = 3;
        gbc.gridy = 0;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.insets = new Insets(20, 10, 10, 20);
        mainPanel.add(card4, gbc);
        card5 = new JToggleButton();
        card5.setAlignmentY(0.5f);
        card5.setBackground(new Color(-855310));
        card5.setBorderPainted(false);
        card5.setContentAreaFilled(false);
        card5.setFocusPainted(false);
        card5.setIcon(new ImageIcon(getClass().getResource("/res/back.png")));
        card5.setIconTextGap(0);
        card5.setMaximumSize(new Dimension(208, 319));
        card5.setMinimumSize(new Dimension(208, 319));
        card5.setOpaque(false);
        card5.setPreferredSize(new Dimension(208, 319));
        card5.setSelected(false);
        card5.setText("");
        card5.setVisible(true);
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.insets = new Insets(10, 20, 10, 10);
        mainPanel.add(card5, gbc);
        card6 = new JToggleButton();
        card6.setAlignmentY(0.5f);
        card6.setBackground(new Color(-855310));
        card6.setBorderPainted(false);
        card6.setContentAreaFilled(false);
        card6.setFocusPainted(false);
        card6.setIcon(new ImageIcon(getClass().getResource("/res/back.png")));
        card6.setIconTextGap(0);
        card6.setMaximumSize(new Dimension(208, 319));
        card6.setMinimumSize(new Dimension(208, 319));
        card6.setOpaque(false);
        card6.setPreferredSize(new Dimension(208, 319));
        card6.setSelected(false);
        card6.setText("");
        gbc = new GridBagConstraints();
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.insets = new Insets(10, 10, 10, 10);
        mainPanel.add(card6, gbc);
        card7 = new JToggleButton();
        card7.setAlignmentY(0.5f);
        card7.setBackground(new Color(-855310));
        card7.setBorderPainted(false);
        card7.setContentAreaFilled(false);
        card7.setFocusPainted(false);
        card7.setIcon(new ImageIcon(getClass().getResource("/res/back.png")));
        card7.setIconTextGap(0);
        card7.setMaximumSize(new Dimension(208, 319));
        card7.setMinimumSize(new Dimension(208, 319));
        card7.setOpaque(false);
        card7.setPreferredSize(new Dimension(208, 319));
        card7.setSelected(false);
        card7.setText("");
        gbc = new GridBagConstraints();
        gbc.gridx = 2;
        gbc.gridy = 1;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.insets = new Insets(10, 10, 10, 10);
        mainPanel.add(card7, gbc);
        card8 = new JToggleButton();
        card8.setAlignmentY(0.5f);
        card8.setBackground(new Color(-855310));
        card8.setBorderPainted(false);
        card8.setContentAreaFilled(false);
        card8.setFocusPainted(false);
        card8.setIcon(new ImageIcon(getClass().getResource("/res/back.png")));
        card8.setIconTextGap(0);
        card8.setMaximumSize(new Dimension(208, 319));
        card8.setMinimumSize(new Dimension(208, 319));
        card8.setOpaque(false);
        card8.setPreferredSize(new Dimension(208, 319));
        card8.setSelected(false);
        card8.setText("");
        gbc = new GridBagConstraints();
        gbc.gridx = 3;
        gbc.gridy = 1;
        gbc.weightx = 1.0;
        gbc.weighty = 1.0;
        gbc.insets = new Insets(10, 10, 10, 20);
        mainPanel.add(card8, gbc);
        triesLabel = new JLabel();
        triesLabel.setHorizontalAlignment(0);
        triesLabel.setHorizontalTextPosition(0);
        triesLabel.setText("Intentos fallidos: 0");
        gbc = new GridBagConstraints();
        gbc.gridx = 0;
        gbc.gridy = 2;
        gbc.gridwidth = 4;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.insets = new Insets(10, 0, 10, 0);
        mainPanel.add(triesLabel, gbc);
    }

    /**
     * @noinspection ALL
     */
    public JComponent $$$getRootComponent$$$() {
        return mainPanel;
    }
}
